(****************************************************************************)
(***                  (c) Copyright by Igor' V. Dikshew                   ***)
(****************************************************************************)

UNIT MOUSEKBD;

INTERFACE

USES  CRT, DOS, GRAPH, DRIVEPCX, text_c;

(* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- *)

TYPE
  MouseSettings = RECORD                { ଠ         }
                    PRESSED : 0..4;      {  ⮩     }
                    X, Y    : WORD;   { न   }
                  END;

  (* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- *)

CONST
  GlobalM : BOOLEAN = FALSE ; { TRUE - ᫨ 㫨      }

  (* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- *)

TYPE

  func = PROCEDURE ;

  MsData = RECORD
             left_pressed, middle_pressed, right_pressed : BOOLEAN;
             actions : WORD;
             row, col : WORD;
           END;

  MsRange = RECORD              { ࠭ ६饭  }
              max_col, min_col, max_row, min_row : WORD;
            END;

  MsMotion = RECORD             {  ६饭  }
               vert, horiz : WORD;
             END;

  MsGraphcur = RECORD            { ᠭ  }
                 row, col : WORD;
                 screen_mask : ARRAY [0..15] OF
                 WORD ;
                 cursor_mask : ARRAY [0..15] OF
                 WORD ;
               END;

  Hardware = RECORD
               start_scan, end_scan : WORD;
             END;

  Software = RECORD
               screen_mask, cursor_mask : WORD;
             END;

  MsSense = RECORD      {  ६饭  ॠ樨  ⨥ }
              h_speed, v_speed, threshold : WORD;
            END;

  MouseFuncv_type = func ;

  MsInterrupt = RECORD
                  IntFunc : MouseFuncv_type;
                  mask : WORD;
                END;

CONST
  _MS_ON      = TRUE;
  _MS_OFF     = FALSE;
  _MS_HIDE    = FALSE;
  _MS_SHOW    = TRUE;

  _MS_MIDDLE =  2;
  _MS_LEFT   =  0;
  _MS_RIGHT  =  1;

  _MS_HARD  =   TRUE;
  _MS_SOFT  =   FALSE;

VAR
  left_event   : BOOLEAN ; {  TRUE ᫨  ᫥ 뢠 }
  middle_event : BOOLEAN ; {  GetStatus 뫠   }
  right_event  : BOOLEAN ; {  ।  ࠢ   }

FUNCTION ResetDriverMouse : WORD;
{ ᫨   ⠭ ,  頥 0 }

PROCEDURE Cursor (Mode : BOOLEAN);
  { 뢠  뢠 }

FUNCTION DriverSize : WORD;
{  ࠩ ?}

PROCEDURE GetMotion (VAR mp : MsMotion);
  { ⠥ MsMotion ?}

FUNCTION GetPage : WORD;
{ ⠥ ⥪ ࠭ }

PROCEDURE GetPress (Button : WORD;
VAR mp : MsData);
  { 頥 ⨥  }

PROCEDURE GetRelease (Button : WORD;
VAR mp : MsData);
  { ⠥ ᢮  }

PROCEDURE GetSensitivity (VAR mp : MsSense);
  { ⠥ MSSense }

PROCEDURE GetStatus (VAR mp : MsData);
  {  ६ Left_event... }

PROCEDURE LightPen (Mode : BOOLEAN);

  (* PROCEDURE RestoreDriver(Buffer: POINTER); *)

PROCEDURE SaveDriver (Buffer : POINTER);

PROCEDURE SetDouble (threshold : WORD);
  { ⠭ ६ 饫窠 -   }

PROCEDURE SetGraphCursor (VAR mp : MsGraphcur);
  { ⠭  짮⥫ }

PROCEDURE SetInterrupt (VAR mp : MsInterrupt);


PROCEDURE SetMickeys (vert, horiz : WORD);
  { ⠭ ⨪  ਧ⠫ ᪮ }

PROCEDURE SetPage (Page : WORD);
  { ⠭  ࠭   }

PROCEDURE SetPosition (row, col : WORD);
  { ⠭   }

PROCEDURE SetRange (VAR mp : MsRange);
  { ⠭ ࠭ ६饭  }

PROCEDURE SetSensitivity (VAR mp : MsSense);
  { ? }

  (* PROCEDURE SwapInterrupt(VAR mp: MsInterrupt); *)

PROCEDURE UpdateScreen (x1, y1, x2, y2 : WORD);
  { ⠭ ࠧ襭   ࠭ }
  { ⠥  ࠢ쭮 ᯮ짮  }

  (* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- *)
  { 頥 TRUE, ᫨ 뫠     }
FUNCTION MousePressed : BOOLEAN;

{ 頥  ⮩   न  }
PROCEDURE ReadMouse (VAR Mi : MouseSettings ) ;

  { 頥 ⮫쪮  ⮩  }
FUNCTION ReadMouseButtom : BYTE;

{ 頥 ⮫쪮 न X  }
FUNCTION Mouse_Col : WORD;

{ 頥 ⮫쪮 न Y  }
FUNCTION Mouse_Row : WORD;

{ 頥  KeyW    }
PROCEDURE UnReadKey (KeyW : WORD);

  { ॢ ⨥     }
  {             䫠 GlobalM            }
PROCEDURE MouseToKey;

  {        }
PROCEDURE WaitKbdAndMouse;

  {  ᪠   }
PROCEDURE ClrMouseBuf;

  { ⠭ ࠭ ६饭  }
PROCEDURE SETMRANGE (x1, y1, x2, y2 : WORD);
  (* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- *)
  IMPLEMENTATION

  (* MSDOS Only  *)

TYPE  setbit = SET OF
  0..1 ;

FUNCTION ResetDriverMouse : WORD;

VAR
  r : REGISTERS;
  status : WORD ;
BEGIN
  r.AX := 0;
  INTR ( $33 , r );
  status := r.AX ;
  IF status = 65535 THEN
     ResetDriverMouse := r.BX
  ELSE
     ResetDriverMouse := 0 ;
END ;

PROCEDURE Cursor ( Mode : BOOLEAN);

VAR
  r : REGISTERS;
BEGIN
  IF Mode = _MS_HIDE THEN
     r.AX := 2
  ELSE
     IF Mode = _MS_SHOW THEN
        r.AX := 1
     ELSE
        EXIT ;

  INTR ( $33, r );
END ;

PROCEDURE GetStatus ( VAR mp : MsData );

VAR
  r : REGISTERS;
BEGIN
  r.AX := 3;
  INTR ( $33, r );
  mp.row := r.DX;
  mp.col := r.CX;
  left_event := FALSE ;
  right_event := FALSE ;
  IF ( mp.left_pressed = FALSE ) AND ( r.BX = 1 ) THEN
     left_event := TRUE ;
  IF ( mp.right_pressed = FALSE ) AND ( r.BX = 2 ) THEN
     right_event := TRUE ;
  mp.left_pressed := FALSE ;
  mp.right_pressed := FALSE ;
  mp.middle_pressed := FALSE ;
  IF ( r.BX >= 1 ) AND ( r.BX <= 3 ) THEN
     BEGIN
     GetRelease ( r.BX, mp ) ;
     CASE r.BX OF
          1 : mp.left_pressed := TRUE ;
          2 : mp.right_pressed := TRUE ;
          3 : mp.middle_pressed := TRUE ;
     END ;
     CASE mp.actions OF
          1 : mp.left_pressed := FALSE ;
          2 : mp.right_pressed := FALSE ;
          3 : mp.middle_pressed := FALSE ;
     END;
     mp.row := r.DX;
     mp.col := r.CX;
  END ;
END ;

PROCEDURE SetPosition (row, col : WORD);

VAR
  r : REGISTERS;
BEGIN
  r.AX := 4;
  r.CX := col;
  r.DX := row;
  INTR ( $33, r );
END ;

PROCEDURE GetPress (Button : WORD;
VAR mp : MsData);

VAR
  r : REGISTERS;
BEGIN
  r.AX := 5;
  r.BX := Button;
  INTR ( $33, r );
  mp.row := r.DX;
  mp.col := r.CX;
  mp.left_pressed := FALSE ;
  mp.right_pressed := FALSE ;
  mp.middle_pressed := FALSE ;
  CASE r.BX OF
       1 : mp.left_pressed := TRUE ;
       2 : mp.right_pressed := TRUE ;
       3 : mp.middle_pressed := TRUE ;
  END ;
  mp.actions := r.BX;
END ;

PROCEDURE GetRelease (Button : WORD;
VAR mp : MsData);

VAR
  r : REGISTERS;
BEGIN
  r.AX := 6;
  r.BX := Button;
  INTR ( $33, r );
  mp.row := r.DX;
  mp.col := r.CX;
  mp.left_pressed := FALSE ;
  mp.right_pressed := FALSE ;
  mp.middle_pressed := FALSE ;
  CASE r.BX OF
       1 : mp.left_pressed := TRUE ;
       2 : mp.right_pressed := TRUE ;
       3 : mp.middle_pressed := TRUE ;
  END ;
  mp.actions := r.BX;
END ;

PROCEDURE SetRange (VAR mp : MsRange);

VAR
  r : REGISTERS;
BEGIN
  r.AX := 7;
  r.CX := mp.min_col;
  r.DX := mp.max_col;
  INTR ( $33, r );
  r.AX := 8;
  r.CX := mp.min_row;
  r.DX := mp.max_row;
  INTR ( $33, r );
END ;

PROCEDURE SetGraphCursor (VAR mp : MsGraphcur);

VAR
  r : REGISTERS;
BEGIN
  r.AX := 9;
  r.BX := mp.col;
  r.CX := mp.row;
  r.DX := OFS (mp.screen_mask);
  r.ES := SEG (mp.screen_mask);
  INTR ( $33, r );
END ;

PROCEDURE GetMotion (VAR mp : MsMotion);

VAR
  r : REGISTERS;
BEGIN
  r.AX := $0B ;
  INTR ( $33, r );
  mp.horiz := r.CX;
  mp.vert := r.DX;
END ;


PROCEDURE SetInterrupt (VAR mp : MsInterrupt);

VAR
  r : REGISTERS;
BEGIN
  r.AX := $0C;
  r.CX := mp.mask;
  r.DX := OFS (mp.IntFunc);
  r.ES := SEG (mp.IntFunc);
  INTR ( $33, r );
END ;

(*
PROCEDURE SwapInterrupt(VAR mp: MsInterrupt);

VAR
                r: Registers;
BEGIN
                r.AX:= $14;
    r.CX:=mp.mask;
    r.DX:=Ofs(mp.IntFunc);
    r.ES:=Seg(mp.IntFunc);
                Intr( $33, r );
                mp.mask:=r.CX;
                mp.IntFunc:=MouseFuncv_type([r.ES: r.DX]);
    RETURN;
END SwapInterrupt;
*)

PROCEDURE LightPen (Mode : BOOLEAN);

VAR
  r : REGISTERS;
BEGIN
  IF Mode = _MS_ON THEN
     r.AX := $0D
  ELSE
     r.AX := $0E ;
  INTR ( $33, r );
END ;

PROCEDURE SetMickeys (vert, horiz : WORD);

VAR
  r : REGISTERS;
BEGIN
  r.AX := $0F ;
  r.CX := horiz;
  r.DX := vert;
  INTR ( $33, r );
END ;

PROCEDURE UpdateScreen (x1, y1, x2, y2 : WORD);

VAR
  r : REGISTERS;
BEGIN
  r.AX := $10 ;
  r.CX := x1;
  r.DX := y1;
  r.SI := x2;
  r.DI := y2;
  INTR ( $33, r );
END ;

PROCEDURE SetDouble (threshold : WORD);

VAR
  r : REGISTERS;
BEGIN
  r.AX := $13 ;
  r.DX := threshold;
  INTR ( $33, r );
END ;

FUNCTION DriverSize : WORD;

VAR
  r : REGISTERS;
BEGIN
  r.AX := $15 ;
  INTR ( $33, r );
  DriverSize := r.BX ;
END ;

PROCEDURE SaveDriver (Buffer : POINTER);

VAR
  r : REGISTERS;
BEGIN
  r.AX := $16 ;
  (*%F _fptr
                r.DX:= WORD(Buffer);
    r.ES:= Seg(CLB._psp);
 %E *)
  (*%T _fptr *)
  r.DX := OFS (Buffer);
  r.ES := SEG (Buffer);
  (*%E *)
  INTR ( $33, r );
END ;

{

PROCEDURE RestoreDriver(Buffer: POINTER);

VAR
    r: SYSTEM.Registers;
BEGIN
    r.AX:=017H;
(*%F _fptr *)
                r.DX:=WORD(Buffer);
    r.ES:=Seg(CLB._psp);
(*%E *)
(*%T _fptr *)
    r.DX:=Ofs(Buffer);
    r.ES:=Seg(Buffer);
(*%E *)
    Lib.Intr(r, 33H);
    RETURN;
END RestoreDriver;

}

PROCEDURE GetSensitivity (VAR mp : MsSense);

VAR
  r : REGISTERS;
BEGIN
  r.AX := $1B ;
  INTR ( $33, r );
  mp.v_speed := r.CX;
  mp.h_speed := r.BX;
  mp.threshold := r.DX;
END ;

PROCEDURE SetSensitivity (VAR mp : MsSense);

VAR
  r : REGISTERS;
BEGIN
  r.AX := $1A ;
  r.BX := mp.h_speed;
  r.CX := mp.v_speed;
  r.DX := mp.threshold;
  INTR ( $33, r );
END ;

PROCEDURE SetPage (Page : WORD);

VAR
  r : REGISTERS;
BEGIN
  r.AX := $1D ;
  r.BX := Page;
  INTR ( $33, r );
END ;

FUNCTION GetPage : WORD;

VAR
  r : REGISTERS;
BEGIN
  r.AX := $1E ;
  INTR ( $33, r );
  GetPage := r.BX ;
END ;

{=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*}

FUNCTION MousePressed : BOOLEAN;
VAR
  MS : MsData;
BEGIN
  GetStatus (MS);
  IF (MS.left_pressed OR MS.right_pressed) THEN
     MousePressed := TRUE
  ELSE
     MousePressed := FALSE;
END;

PROCEDURE ReadMouse (VAR Mi : MouseSettings);
VAR
  MS : MsData;
BEGIN
  GetStatus (MS);
  Mi.X := MS.col;
  Mi.Y := MS.row;
  IF MS.left_pressed THEN
     Mi.PRESSED := 1 ELSE
     IF MS.right_pressed THEN
        Mi.PRESSED := 3 ELSE
        Mi.PRESSED := 0;
END;

FUNCTION ReadMouseButtom : BYTE;
VAR
  Mi : MouseSettings;
BEGIN
  ReadMouse (Mi);
  ReadMouseButtom := Mi.PRESSED;
END;

FUNCTION Mouse_Col : WORD;
VAR
  Mi : MouseSettings;
BEGIN
  ReadMouse (Mi);
  Mouse_Col := Mi.X;
END;

FUNCTION Mouse_Row : WORD;
VAR
  Mi : MouseSettings;
BEGIN
  ReadMouse (Mi);
  Mouse_Row := Mi.Y;
END;

PROCEDURE UnReadKey (KeyW : WORD);
CONST
  KbdStart = $1E;
  KbdEnd   = $3C;
VAR
  KbdHead : WORD ABSOLUTE $40 : $1A;
  KbdTail : WORD ABSOLUTE $40 : $1C;
  OldTail : WORD;
BEGIN
  OldTail := KbdTail;
  IF KbdTail = KbdEnd THEN
     KbdTail := KbdStart ELSE
     INC (KbdTail, 2);
  IF KbdTail = KbdHead THEN
     KbdTail := OldTail ELSE
     MemW [$40 : OldTail] := KeyW;
END;

PROCEDURE MouseToKey;
BEGIN
  CASE ReadMouseButtom OF
       0 :  GlobalM := FALSE;
       1 : BEGIN
       UnReadKey (13);
       GlobalM := TRUE;
       END;
       3 : BEGIN
       UnReadKey (27);
       GlobalM := TRUE;
       END;
  END;
END;

PROCEDURE ClrMouseBuf;
BEGIN
  WHILE MousePressed DO
        DELAY (2);
END;

PROCEDURE WaitKbdAndMouse;
BEGIN
  REPEAT
  UNTIL KEYPRESSED OR MousePressed;
END;

PROCEDURE SETMRANGE (x1, y1, x2, y2 : WORD);
VAR mp : MsRange;
BEGIN
  mp.max_col := x1;
  mp.min_col := x2;
  mp.max_row := y1;
  mp.min_row := y2;
  SetRange (mp);
END;

END.
